import { defineComponent as ae, ref as d, onMounted as J, withDirectives as le, createVNode as r, mergeProps as V, resolveComponent as T, resolveDirective as ie, unref as ne, nextTick as K, isVNode as ue, toRef as G, Fragment as oe } from "vue";
import re from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as A } from "../../customElement/index.js";
import "../../form/index.js";
import { tableProps as de, tableEmits as ce } from "./props.js";
import { Check as se, Close as me, Edit as ve } from "@element-plus/icons-vue";
import { createNamespacs as fe, getValue as H } from "@tomiaa/utils";
import "../../theme-chalk/lib/vue3-components/table.js";
import { useI18n as ge } from "vue-i18n";
function he(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !ue(e);
}
const y = fe("table"), Oe = ae({
  name: "KTable",
  props: de,
  emits: ce,
  setup(e, {
    attrs: k,
    slots: D,
    emit: f,
    expose: _
  }) {
    const {
      t: B
    } = ge(), C = d(""), I = d(""), {
      append: W,
      empty: X = () => e.emptyTip && P.value && C.value,
      page: Y,
      editControlIcon: L,
      editIcon: N
    } = D, g = d({}), h = d({}), Z = (s) => s == null ? void 0 : s.map((m) => {
      const x = {};
      for (const a in m)
        x[a] = ne(m[a]);
      for (const a in m)
        if (typeof m[a] == "string" && /^(\$t\(|t\()/.test(m[a]) && /\)$/.test(m[a])) {
          let l = m[a].replace(/^(\$t\(|t\()/, "");
          l = l.replace(/\)$/, ""), l = l.replace(/(^'|^"|'$|"$)/g, ""), x[a] = B(l);
        }
      const {
        slot: b,
        action: w,
        actionConfig: t,
        editable: R,
        editableConfig: o,
        ...S
      } = x, i = {
        header: D.header,
        default: b && D[b]
      };
      if (e.editRow && (i.default = (a) => {
        const {
          row: l,
          column: c,
          $index: n
        } = a;
        return r("div", {
          class: [y.e("editable"), y.is("editable", g.value[n])]
        }, [g.value[n] ? r(T("el-input"), {
          size: "small",
          modelValue: h.value[n][c.property],
          "onUpdate:modelValue": (v) => h.value[n][c.property] = v
        }, null) : l[c.property]]);
      }), (w || t) && (i.default = (a) => {
        var v;
        const {
          $index: l,
          row: c
        } = a;
        let n = [{
          el: "el-button",
          size: "small",
          "v-if": typeof (t == null ? void 0 : t.showEdit) < "u" ? t == null ? void 0 : t.showEdit : e.actionConfig.showEdit,
          onClick: () => {
            if (e.editRow) {
              if (g.value[l]) {
                Object.assign(a.row, h.value[l]), delete h.value[l], delete g.value[l], f("confirmEditRow", a);
                return;
              }
              h.value[l] = JSON.parse(JSON.stringify(c)), g.value[l] = !0;
            }
            f("edit", a);
          },
          children: g.value[l] ? (t == null ? void 0 : t.editRowEnterText) || e.actionConfig.editRowEnterText || "\u786E\u5B9A" : (t == null ? void 0 : t.editText) || e.actionConfig.editText || "\u7F16\u8F91"
        }, {
          el: "el-button",
          size: "small",
          type: "danger",
          "v-if": typeof (t == null ? void 0 : t.showDelete) < "u" ? t == null ? void 0 : t.showDelete : e.actionConfig.showDelete,
          onClick: () => {
            if (e.editRow) {
              delete h.value[l], delete g.value[l], f("cancelEditRow", a);
              return;
            }
            f("delete", a);
          },
          children: g.value[l] ? (t == null ? void 0 : t.editRowCloseText) || e.actionConfig.editRowCloseText || "\u53D6\u6D88" : (t == null ? void 0 : t.deleteText) || ((v = e.actionConfig) == null ? void 0 : v.deleteText) || "\u5220\u9664"
        }];
        return e.actionConfig.custom && (n = e.actionConfig.custom(n, a)), t != null && t.custom && (n = t.custom(n, a)), r(A, {
          list: n
        }, null);
      }), R || o) {
        const a = d({}), l = d({});
        i.default = (c) => {
          const {
            row: n,
            column: v,
            $index: ee
          } = c, u = v.id + ee, M = () => {
            delete l.value[u], delete a.value[u];
          };
          let O = [{
            el: "el-icon",
            color: "var(--el-color-success)",
            size: "1.2em",
            "v-if": o == null ? void 0 : o.showEnter,
            onClick() {
              n[v.property] = l.value[u], M(), f("confirmEditCell", c);
            },
            children: se
          }, {
            el: "el-icon",
            size: "1.2em",
            color: "var(--el-color-danger)",
            "v-if": o == null ? void 0 : o.showClose,
            onClick() {
              M(), f("cancelEditCell", c);
            },
            children: me
          }];
          return o != null && o.custom && (O = o.custom(O, c, G(a.value, u))), r("div", {
            class: [y.e("editable"), y.is("editable", a.value[u])]
          }, [a.value[u] ? r(T("el-input"), {
            size: "small",
            modelValue: l.value[u],
            "onUpdate:modelValue": (te) => l.value[u] = te
          }, null) : n[v.property], a.value[u] ? r(oe, null, [
            (L == null ? void 0 : L({
              ...c,
              isEdit: G(a.value, u)
            })) || r(A, {
              list: O
            }, null)
          ]) : N ? r("span", {
            onClick: () => {
              l.value[u] = n[v.property];
            }
          }, [N({
            ...c,
            isEdit: G(a.value, u)
          })]) : r(T("el-icon"), {
            size: "1.2em",
            onClick: () => {
              l.value[u] = n[v.property], a.value[u] = !a.value[u];
            }
          }, {
            default: () => [r(ve, null, null)]
          })]);
        };
      }
      return r(T("el-table-column"), S, he(i) ? i : {
        default: () => [i]
      });
    }), p = () => r(T("el-pagination"), V({
      class: y.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: q.value,
      pageSize: F.value,
      total: U.value,
      ref: E,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, k, {
      "onUpdate:currentPage": async (s) => {
        q.value = s, await K(), z();
      },
      "onUpdate:page-size": async (s) => {
        F.value = s, await K(), z();
      }
    }), {
      default: Y
    }), E = d(), Q = d(), $ = d(null), U = d(0), q = d(e.defaultCurrentPage || 1), F = d(e.defaultPageSize || 10), P = d(!1), z = () => {
      var R, o, S;
      P.value = !0, $.value = null;
      let s;
      e.emptyTip && (C.value = e.emptyTip, clearTimeout(s), s = setTimeout(() => {
        C.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let m;
      e.elLoadingTextTimeoutText && (I.value = e.elementLoadingText, clearTimeout(m), setTimeout(() => {
        const i = document.querySelector(".el-loading-text");
        i && (i.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const x = e.server, b = {
        [((R = e.replaceFields) == null ? void 0 : R.pageSize) || "pageSize"]: E.value.pageSize,
        [((o = e.replaceFields) == null ? void 0 : o.currentPage) || "currentPage"]: E.value.currentPage
      }, w = {};
      if (e.withDataPath !== !1) {
        const i = {
          get: "params",
          post: "data"
        }, a = e.withDataPath || i[(((S = e.getConfig) == null ? void 0 : S.method) || "get").toLocaleLowerCase()];
        a && (w[a] = {});
        const l = w[a] || w;
        Object.assign(l, e.withPagePath && typeof e.withPagePath == "string" ? {
          [e.withPagePath]: b
        } : b), Object.assign(l, e.withQueryPath && typeof e.withQueryPath == "string" ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery);
      }
      const t = {
        url: e.getUrl,
        ...w,
        ...e.getConfig
      };
      e.stringify && t.data && (t.data = re.stringify(t.data)), f("beforeGetData", t), x(t).then((i) => {
        f("afterGetData", i), $.value = H(e.dataPath, i), U.value = H(e.totalPath, i);
      }).catch((i) => {
        f("failToGetData", i);
      }).finally(() => {
        clearTimeout(s), clearTimeout(m), P.value = !1;
      });
    };
    e.showPagination && J(z);
    const j = {
      getData: z
    };
    return J(() => {
      j.elPagination = E.value, j.elTable = Q.value;
    }), _(j), () => le(r("div", V({
      class: y.b(),
      "element-loading-text": I.value
    }, k), [r(T("el-table"), V({
      data: $.value,
      ref: Q
    }, k), {
      default: () => [Z(e.options)],
      append: W,
      empty: X
    }), e.showPagination && p(), e.showLoadInGet && P.value]), [[ie("loading"), e.showLoadInGet && P.value]]);
  }
});
export {
  Oe as default
};
